#ifndef EVSE_COMMANDS_H
#define EVSE_COMMANDS_H

#include <stdio.h>
#include "sdkconfig.h"

#define MAXDIRLEN 256


#ifdef CONFIG_COMMANDS_TELNET_SERVER

#ifdef ESP32
#define LISTEN_PORT 23
#else
#define LISTEN_PORT 23023
#endif

void telnetCloseAll();

#endif /*CONFIG_COMMANDS_TELNET_SERVER */

#ifdef ESP32
#define YIELD() vTaskDelay(50)
#else
#define YIELD() vTaskDelay(250)
#endif
#define YIELDS() vTaskDelay(2)
#define UNUSED(x) x  __attribute__((unused))

#define PRO_CPU 0
#define APP_CPU 1

#define STD_TASK_PRIO 5

//extern "C" void task_test_display(void *ignore);
void commands_Initialize(void);

//int network_connect(FILE *fp);
//void network_start(FILE*fp);  // start a task that will try to connect to the network every x seconds

extern char currDir[MAXDIRLEN];

void commandLoop(FILE *fd_stdin, FILE *fd_stdout);

void sendEspNetworkEvent (int connected);

void showWelcomeMsg(FILE*fp);

int catFile (FILE *fd, char*fileName);

void esp32_initialize_console();

#ifdef ESP32
#define MOUNT_PATH "/data"
#else
#define MOUNT_PATH "./data"
#endif

void initialize_filesystem();

#ifdef CONFIG_COMMANDS_I2C
void i2c_init();
#endif


#endif
