/* EVSE_AD - mcp23017 portio

   Armin Diehl <ad@ardiehl.de> June 15, 2018

   Jun 25, 2018 AD:	initial version


   Unless required by applicable law or agreed to in writing, this
   software is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
   CONDITIONS OF ANY KIND, either express or implied.
*/

#ifndef MAIN_MCP23017_PORTIO_H_
#define MAIN_MCP23017_PORTIO_H_

#include <inttypes.h>

#ifdef ESP32
#include "driver/i2c.h"
#endif

#include "mcp23017.h"

// max mumber of MCP20017
#define PIO_MAX 2


// ---- configuration ---------------------------------------------------------------------

// init without driver install
int pio_init(int mcpIdx, uint8_t i2c_addr, i2c_port_t port);

#ifdef ESP_PLATFORM
// including driver install
int pio_init(int mcpIdx, mcp23017_t * nmcp);
#endif
// set pins given (=1) to output. leave other pin configuration untouched
int pio_setPinsOutput (int mcpIdx, uint16_t mask);

// set pins given (=1) to input. leave other pin configuration untouched
int pio_setPinsInput (int mcpIdx, uint16_t mask, int pullup = 0);

// ---- in/out ----------------------------------------------------------------------------
int pio_getByte (int mcpIdx, int hiByte, uint8_t * value);

int pio_setPins (int mcpIdx, uint16_t mask);
int pio_clearPins (int mcpIdx, uint16_t mask);


#endif /* MAIN_MCP23017_PORTIO_H_ */
