/*
 * evse_event.h
 *
 *  Created on: Dec 19, 2017
 *      Author: ad
 */

#include "freertos/FreeRTOS.h"

#define EV_RC_OK 0
#define EV_RC_NOEVENT 1
#define EV_RC_INVALID 2

#ifndef MAIN_EVSE_EVENT_H_
#define MAIN_EVSE_EVENT_H_

#define EV_QUEUE_LENGTH 16

#define EV_TGT_TASKS 6

#define EV_TASK_UI        0x0001
#define EV_TASK_INVERTER  0x0002
#define EV_TASK_J1772     0x0004
#define EV_TASK_METER     0x0008
#define EV_TASK_NETWORK   0x0010
#define EV_TASK_MQTT      0x0020

#define EV_TASK_ALL EV_TASK_UI+ EV_TASK_INVERTER+ EV_TASK_J1772+ EV_TASK_METER+ EV_TASK_NETWORK+ EV_TASK_MQTT
#define EV_TASK_NET EV_TASK_UI+ EV_TASK_INVERTER+ EV_TASK_MQTT
#define EV_TASK_KEYS EV_TASK_UI

#define EV_KEY_UP		5
#define EV_KEY_DN		24
#define EV_KEY_OK		13
#define EV_KEY_BACK		8


#define ev_data_t int
#define EV_DATA_NONE 0

typedef int ev_event_t;

const char * eventTxt(ev_event_t e);

#define EV_IGNORE					0
#define EV_NET_CONNECTED 			10
#define EV_NET_DISCONNECTED 		11
#define EV_KEY_PRESS				50
#define EV_KEY_RELEASE				51
#define EV_UI_TIMER_PAGE			60
#define EV_UI_TIMER_TIMEOUT			61
#define EV_UI_REDRAW				70
#define EV_AVAILABLE_PWR_CHANGE		80
#define EV_CONSUMED_PWR_CHANGE      81
#define EV_CAR_POWER_PHASES_CHANGE	82
#define EV_PWMAMPS_CHANGE           83
#define EV_MINAMPS_CHANGE           84
#define EV_MAXAMPS_CHANGE           85
#define EV_CABLE_CHANGE             90
#define EV_CAR_CHARGE_VENT			100
#define EV_CAR_CHARGE     			101
#define EV_CAR_READY     			102
#define EV_MQTT_CONNECTED			110
#define EV_MQTT_DISCONNECTED		111
#define EV_MQTT_SEND_TIMER          112
#define EV_MQTT_INTERVAL_CHANGE     113
#define EV_EM_DATA_CHANGED          120



#define EV_END_TASK					9999



typedef struct{
	ev_event_t event;
	ev_data_t  data;
} ev_event_data_t;


void ev_initialize(void);
void ev_send      (int targets, ev_event_t event, ev_data_t data);
int ev_receive (int whoAmI, ev_event_t *event, ev_data_t *data, TickType_t xTicksToWait = 0);





#endif /* MAIN_EVSE_EVENT_H_ */
