/*
 * evse_global.h
 *
 *  Created on: Dec 19, 2017
 *      Author: ad
 */

#ifndef MAIN_EVSE_GLOBAL_H_
#define MAIN_EVSE_GLOBAL_H_

#include "sdkconfig.h"
#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/queue.h"
#include "freertos/event_groups.h"
#include "freertos/timers.h"
#include "cons.h"

#define EVSE_STD_TASK_PRIO 5

// when running the inverter task under linux, at least 50 is required under freertos emu
// native linux worked fine without delays
#ifdef ESP_PLATFORM
#define YIELD() vTaskDelay(50)
#else
#define YIELD() vTaskDelay(250)
#endif

#define FFLUSH(F)fflush(F); vTaskDelay(50)

#define YIELDS() vTaskDelay(2)
#define YIELDms(ms) vTaskDelay(pdMS_TO_TICKS(ms))

#define UNUSED(x) x  __attribute__((unused))

#define PRO_CPU 0
#define APP_CPU 1

#ifdef ESP_PLATFORM
#include "esp_err.h"
#include "esp_system.h"
#include "esp_log.h"
#include "driver/i2c.h"
#else  // ESP32
#include "esp_compat.h"
#endif // ESP32

#include "evse_event.h"
#include "configfile.h"

#define EVSE_I2C_MASTER_NUM I2C_NUM_1   /*!< I2C port number for master dev */
//#define EVSE_I2C_MASTER_TX_BUF_DISABLE   0   /*!< I2C master do not need buffer */
//#define EVSE_I2C_MASTER_RX_BUF_DISABLE   0   /*!< I2C master do not need buffer */
//#define EVSE_I2C_MASTER_FREQ_HZ    100000     /*!< I2C master clock frequency */
#define EVSE_MCP_ADDR				0x20	/* mcp23017 i2c address */
// SDA - GPIO21
//#define EVSE_I2C_PIN_SDA (gpio_num_t)4
// SCL - GPIO22
//#define EVSE_I2C_PIN_SCL (gpio_num_t)16



#endif /* MAIN_EVSE_GLOBAL_H_ */
