/*
 * evse_keys.h
 *
 * handle keys
 * the keys i used are china sensor-touchkeys so they will not bounce. However, the code implements
 * some simple debounce in case other keys will be used in the future
 *
 *  Created on: Feb 3, 2018
 *      Author: Armin Diehl <ad@ardiehl.de>
 *
  *  June 24, 2018 AD: input changed to mcp23017 via i2c
 */

#ifndef MAIN_EVSE_KEYS_H_
#define MAIN_EVSE_KEYS_H_

#include "evse_global.h"

// is set, a release event will be send
//#define KEY_ENABLE_RELEASE_EVENT

#define USE_PIO

#ifdef USE_PIO
// define bits and port

// mcp23017 index
#define KEY_PIO_IDX		0

// bits for keys
#define KEY_BIT_UP		3
#define KEY_BIT_DN		4
#define KEY_BIT_BACK		5
#define KEY_BIT_OK		6

// in which of the two bytes the mcp23017 has: 0=A,1=B
#define KEY_PIO_BYTE    0
#else
// define gpio ports for keys
#define KEY_PORT_UP		GPIO_NUM_32
#define KEY_PORT_DN		GPIO_NUM_39
#define KEY_PORT_BACK	GPIO_NUM_36
#define KEY_PORT_OK		GPIO_NUM_5
#endif

#define KEY_MAX			4

#define KEY_DEBOUNCE_MS		150
#define KEY_WAIT_IF_NO_KEY	250

// the following are in units of 100 ms
#define KEY_AUTOREPEAT_WAIT_FIRST	9		/* wait after first keypress until starting autorepeat */
#define KEY_AUTOREPEAT_WAIT			3		/* wait between autorepeating keys */

void keys_initialize(FILE *fd);

int keys_startTask(FILE *fp);
int keys_endTask(FILE *fd);


void register_keysCommands();  /* register console commands */


#endif /* MAIN_EVSE_KEYS_H_ */
